If Condition


 
Thread Tools Search this Thread
Top Forums Shell Programming and Scripting If Condition
# 8  
Old 01-28-2011
[CODE]
eval $lgrep $SAM_CMD ; if [ $? -eq 0 ] ; then echo "No Error" ; fi
change to
eval $lgrep $SAM_CMD ; rslt=$? ; if [ "$rslt." = "0." ]; then echo "No Error"; fi

Last edited by aix-guy; 01-28-2011 at 03:25 PM.. Reason: missed the period ofert the 0
# 9  
Old 01-28-2011
The original error message came from the extra semi-colon after "then".

Please post all relevant parts of the script, or the whole script.
Please post the command and the lines which set the variables.

It think I get your logic but I can't think of a simple grep which would return exit status zero when it doesn't find something. Obviously "grep -v" is irrelevant in this context.
Code:
eval $lgrep $SAM_CMD ; if [ $? -ne 0 ] ; then echo "No Error" ; fi

Btw. If this is commercial code it is rarely ever necessary or desirable to use "eval".
In portable Shell scripts I have seen commands like echo executed as ECHO where ECHO is a function which decides which syntax to use.
# 10  
Old 01-28-2011
You can do the conditional test as follows
Code:
 [ "$?" -ne 0 ] && echo "No Error"

. I'm not sure what you're doing with the first part but this code here reads "Test exit status to be not equal to 0 and if that evaluates to true, echo 'No Error'. I prefer the conditional test like above as opposed to if statements. Keeps code cleaner imho.

&& says do this code if the code to the left is true. || says do this if it fails or is not true. Good for one liners instead of worrying about if then syntax. Hope that helps a little for the future :-)

Last edited by DC Slick; 01-28-2011 at 03:55 PM.. Reason: further explaination
# 11  
Old 01-28-2011
DC Slick -

What is the complete command?

Code:
eval $lgrep $SAM_CMD ; if [ "$?" -ne 0 ] && echo "No Error"; fi

---------- Post updated at 12:13 PM ---------- Previous update was at 12:12 PM ----------

Aix Guy -

I tried running it, but it is giving me error message, even when the command has an output.

---------- Post updated at 12:14 PM ---------- Previous update was at 12:13 PM ----------

Methyl -

The condition has changed, i want an message when output is null.

Also, eval is because i am using pipe within variables.
# 12  
Old 01-28-2011
Please expand the variables so I can see what is in them. It could be something in them that the parse is not getting right.
# 13  
Old 01-28-2011
If you could tell us what $lgrep and $SAM_CMD represent that would help so much. Give us an example of what those variable values are. That's what aix-guy means by expand the variables. With the test [ "$?" -ne 0 ] && echo "No Error" you don't need the IF. So
Code:
 eval "$lgrep" "$SAM_CMD"; [ "$?" -ne 0 ] && echo "No Error"

is all you need.
# 14  
Old 01-28-2011
Code:
Also, eval is because i am using pipe within variables.

Please post the whole script and sample command calls (if relevant). Perhaps there is a better way?
Login or Register to Ask a Question

Previous Thread | Next Thread

10 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

Help with if condition

o/p of my command is given below My requirement is if Pnumber is 0 then stabilization.Build.2013 else stabilization.PBuild.2013.3 (11 Replies)
Discussion started by: nikhil jain
11 Replies

2. UNIX for Dummies Questions & Answers

IF [ condition ] help

Hi all Unix newbie - please be gentle Am modifying an existing script to error trap a variable with a length of 0 #!/bin/bash ipfile='/var/data/bin/ipaddress' ] && ipold="$(< "$ipfile" )" ipnew="$( wget -q -O - checkip.dyndns.org | sed -e 's/.*Current IP Address: //;s/<.*$//' )" #... (6 Replies)
Discussion started by: CRChamberlain
6 Replies

3. Shell Programming and Scripting

If condition return 0 even when it fails to satisfy te condition

HI My doubt may be basic one but I need to get it clarified.. When i use "if" condition that checks for many AND, OR logical conditions like if ]; then return 0 fi Even the if condition fails it returns as zero.. Any clue.. But if i add else condition like if ]; ... (2 Replies)
Discussion started by: Priya Amaresh
2 Replies

4. Shell Programming and Scripting

if condition

if chr1:109457160 1 109457160 99.1735537190083 + chr1:109457233 1 109457233 99.1735537190083 - chr1:109457614 1 109457614 99.1735537190083 + chr1:109457618 1 109457618 100 + chr1:109457943 1 109457943 100 - chr1:109458224 1 109458224 99.1735537190083 - file1.txt If 6th column in... (3 Replies)
Discussion started by: johnkim0806
3 Replies

5. Shell Programming and Scripting

redirect stdout echo command in condition A run in condition B

hi, I have some problems in my simple script about the redirect echo stdout command inside a condition. Why is the echo command inside the elif still execute in the else command Here are my simple script After check on the two diff output the echo stdout redirect is present in two diff... (3 Replies)
Discussion started by: jao_madn
3 Replies

6. HP-UX

Difference between [condition] and [[condition]] and ((condition)) when used with if condition

Executed the following if conditions .. and got different results . only (( )) gave correct o/p with all scenarios . Can anybody please let me know what is the difference between and ] and ((condition)) when used with if condition. And why each condition gave different result. 1.... (2 Replies)
Discussion started by: soumyabubun
2 Replies

7. Shell Programming and Scripting

or in a IF condition

Hi I have to evaluate multiple conditions with an 'or'. Here is an example: if when i use the above i get a error message ' Please help me to know if i am missing something in the syntax. how do i achieve multiple "or" in the same if condition. Thanks. (11 Replies)
Discussion started by: sunrexstar
11 Replies

8. Shell Programming and Scripting

if..else condition

i have a paramter data_date in which i am passing a string value.i want to find out another paramter file_date from this.the logic is given below if day of data_date = sunday or monday then file_date=data_date-1 else file_date=data_date-2 i am passing data_date as 20061027. how can i... (3 Replies)
Discussion started by: dr46014
3 Replies

9. Shell Programming and Scripting

if condition

Hi friends, :) In a shell script i found the following if condition. echo -n "Which version of $1 do you want to restore ('0' to quit)? : " read desired if ${desired:=1} -ge $index ] ; then echo "$0: Restore canceled by user: index value too big." >&2 exit 1 fi Can... (1 Reply)
Discussion started by: ravi raj kumar
1 Replies

10. Shell Programming and Scripting

if condition ...

i have following if condition if above statement is case sensitive.....what is syntax if i have to make above comparision case insensetive (4 Replies)
Discussion started by: mahabunta
4 Replies
Login or Register to Ask a Question